//*****************************************************************************
// external_variables.h 
// Project Name - Error Calculator
// Company Name- Zera India Private Limited.  
// Author - Rajesh Varma
// Date - 04/09/2017
// Revision - 0
// Remarks
//
//*****************************************************************************



#ifndef __variables_H
#define __variables_H

extern unsigned char Timer_tick;
extern unsigned int disp_para_cnt;
extern unsigned int boot_cnt;
extern unsigned int Copy_error_calc;
extern unsigned int fout_intCount; 
extern unsigned int switch_press_S1;
extern unsigned int reset_count;
extern unsigned int Temp_pulses;
extern unsigned int DLMS_Temp_Index;
extern unsigned int Command_length;
extern unsigned char response_buffer[1024];
extern unsigned char ascii_convert_buff[1024];
extern unsigned char C_ascii_convert_buff[1024];



extern unsigned char Error_Display_Seq;
extern unsigned char single_flag,continuous_flag;
extern unsigned char SC_PULSE_Selection;
extern unsigned char DLMS_Read_Flag;
extern unsigned char transperent_mode;
extern unsigned char decimal_position;
extern unsigned char once_display_hdlc;
extern unsigned char Measuremnt_flag;
extern unsigned char start_measurement_flag,stop_measurement_flag;
extern unsigned char reset_flag,reset_count_flag;
extern unsigned char pulse_received;
extern unsigned char timer_start_flag,zero_flag;
extern unsigned char Switch_debounce_flag;
extern unsigned char boot_flag,Edit_Enable;
extern unsigned char display_flag;
extern unsigned char reset_count_flag;
extern unsigned char reset_status_flag;
extern unsigned char Freeze_position;
extern unsigned char start_edge_flag;
extern unsigned char echo_flag,response_timeout;
extern unsigned char Timeout_cnt;
extern unsigned char cir_buffer_2[5000];
extern unsigned char cir_buffer[5000];
extern unsigned char cir_buffer_uart0[5000];
extern unsigned char first_edges_flag;
extern unsigned char length_query,length_query1,length_query2,complete_length,hex_count;
extern unsigned char BCC_check;
extern unsigned char DLMS_Buffer[1024];
extern unsigned char C_DLMS_Buffer[1024];
extern unsigned char Meter_Data_Ready;
extern unsigned char disp_cnt;
extern unsigned char clean_flag;
extern unsigned char c_pre_data[3];
extern unsigned char single_meas;




extern char pcBuffer[40];
extern char error_buff[9],C_error_buff[4],lcd_disp[7];
extern char Higher_error_flag;
extern char Start_postion,End_postion;
extern char Received_ID;
extern char Eneterd_Slave_ID;
extern char Temp_arrray[7];
extern char edge_accuracy_switch;
extern char edge_buff[7],Edge_mode_flag;
extern char Start_temp[3];
extern char End_temp[3];
extern char result_display;
extern char DLMS_Temp_buff[255];






extern double N_Must;
extern double error_calc;
extern double   N_Actual;
extern double master_meter_constant;


extern volatile unsigned char measurement_status_flag;
extern volatile unsigned char UAR0_Received_flag,UAR1_Received_flag,UAR2_Received_flag;
extern volatile unsigned char byte0,byte1,byte2,byte3,byte4;
extern volatile unsigned int string_length;
extern volatile unsigned int pulse_count,temp_pulse;
extern volatile unsigned long Edge_count,C_Edge_count;
extern volatile unsigned int Length_Received_Buff;





extern int x,i;
extern unsigned long  ulAnimPos, ulColor;
extern unsigned long master_meter_pulse;
extern unsigned int pui32Read;



extern tContext sContext_Label;
extern tRectangle sRect_Label;
extern tContext sContext_Meas_set[6][2];
extern tRectangle sRect_Meas_set[6][2];


//*********Flags for various opertaions*******************//
struct Flags
{
    unsigned char Start_Pressed : 1;
    unsigned char Stop_Pressed : 1;
    unsigned char N_Actual_Ready : 1;
    unsigned char Pulse_Received : 1;
    unsigned char Error_Screen : 1;
    unsigned char Data_Update : 1;
    unsigned char Error_Displyed_Once : 1;
    unsigned char Edgecount_Screen:1;
}; extern struct Flags  Flag;


struct Meter_postion
{
    char Slave_ID[2];
    char Slave_ID_flash;
    char First_boot;

};
extern struct Meter_postion Meter_Place;

union Data_query
{
    char data_length[2];
    int data_value;

};extern union Data_query Receive_Query_length;


//**********************************************************//


extern void boot_screen_Load(void);
extern void boot_screen_Load(void);
extern void Err_measure_Page_Fix_Graphics(void);
extern void Err_measure_Page_Update(void);
extern void Editbutton_Page_Fix_Graphics(void);
extern void Editbutton_Page_Update(void);
extern void Edgecount_Page_Fix_Graphics(void);
extern void Edgecount_Page_Update(void);


extern void calculate_error(void );
extern void single_measurement(void);
extern void value_trancation(unsigned char);
extern void start_measurment(void);
extern void Timer6_start(void);
extern void Switch_init(void);
extern void switch_sense(void);
extern void Fix_Graphics(void);
extern void Null_char_position(register unsigned char , char *);
extern void End_with_percentage_sign(register unsigned char position, char *array);
extern void divide_display(void);
extern void Clean_divide_display(void);
extern void Pulse_sense_interrupt(void);
extern void UARTSend(const unsigned char *pucBuffer, unsigned long ulCount);
extern void UARTSend_PC(const unsigned char *pucBuffer, unsigned long ulCount);
extern void UARTSend_BL(const unsigned char *pucBuffer, unsigned long ulCount);
extern void send_acknowledgement(void);
extern void send_version_HWACK(void);
extern void send_version_SWACK(void);
extern void send_accuracy_results(void);
extern void send_edge_results(void);
extern void send_DLMS_response(void);
extern void send_status_ack(void);
extern void ENABLE_PIN(void);
extern void DISABLE_PIN(void);
extern void Clear_UART0_Buffer(void);
extern void Clear_UART1_Buffer(void);
extern void single_continuous(void);
extern void Edge_count_fun(void);
extern void ASCII_HEX_CONVERTER(unsigned char);
extern void HEX_ASCII_CONVERTER(void);
extern void Single_init(void);
extern void Continue_init(void);
extern void length_calculate(void);
extern void common_position_query(void);
extern void Uart0_init(unsigned int);
extern void Uart1_pc_init(unsigned int);
extern void clear_display(void);
extern void RS485_communication(void);
extern void External_pulse_init(void);
extern void fout_counter_init(void);
extern void Data_write(void);
extern void Data_read(void);
extern void boot_write(void);
extern void Debug_display(void);


#endif

