//*****************************************************************************
/// Edit_mode.c

/// Company Name- Zera India Private limited.  
/// Author - Rajesh Varma
/// Date - 26/12/2020
/// Revision - 0


/// Remarks: Main loop consist of diffrent function implemented in switch case
///
//****************************************************************************
#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include "inc/hw_memmap.h"
#include "driverlib/sysctl.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "grlib/grlib.h"
#include "drivers/frame.h"
#include "drivers/kentec320x240x16_ssd2119.h"
#include "drivers/pinout.h"
#include "macros.h"
#include "extern_variables.h"

//*********************************************************************************************
///
/// void Editbutton_Page_Fix_Graphics(void)
/// I/p: Nothing
/// O/P: Noting
/// Remark: This function will display edit button screen
//**********************************************************************************************

void Editbutton_Page_Fix_Graphics(void)
{
    Fix_Graphics();
    GrContextFontSet(&sContext_Label, &g_sFontCmss26b);
    GrContextForegroundSet(&sContext_Label, ClrWhite);
    GrStringDrawCentered(&sContext_Label,"EDIT MODE", -1,GrContextDpyWidthGet(&sContext_Label) / 2, 15, 0);

    GrContextFontSet(&sContext_Label, &g_sFontCmss48b);
    GrContextForegroundSet(&sContext_Label, ClrRed);
    GrStringDrawCentered(&sContext_Label,"POSITIONS", -1,GrContextDpyWidthGet(&sContext_Label) / 2, 85, 0);

  GrContextInit(&sContext_Label, &g_sKentec320x240x16_SSD2119); //LCD Intialisation
    sRect_Meas_set[0][0].i16XMin = 20;
    sRect_Meas_set[0][0].i16YMin = 176;
    sRect_Meas_set[0][0].i16XMax = 300;
    sRect_Meas_set[0][0].i16YMax = 204;


}


/*********************************************************************************************
///
/// void Editbutton_Page_Update(void)
/// I/p: Nothing
/// O/P: Noting
/// Remark: This function will update display of edit button screen
**********************************************************************************************/

void Editbutton_Page_Update(void)
{

    GrContextFontSet(&sContext_Label, &g_sFontCmss48b);//g_sFontCmss72i     g_sFontCmss48b
    GrContextForegroundSet(&sContext_Label, ClrWhite);
    GrContextBackgroundSet(&sContext_Label, BACKGROUND_COLOR);
    sprintf(pcBuffer, "%d",Eneterd_Slave_ID );
    Null_char_position(4,&pcBuffer[0]);
    GrStringDraw(&sContext_Label, pcBuffer, -1, 150,140, 1);
}
